package ca.thetechrobo.steakonfirstjoin;

import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.TextColor;

public class GiveSteakToPlayer implements Listener {
	private SteakOnFirstJoin pl;
	public boolean canPlayerGetSteak(Player p) {
		PersistentDataContainer cont = p.getPersistentDataContainer();
		NamespacedKey key = new NamespacedKey(this.pl, "canHasSteak");
		return !(cont.has(key));
	}
	public void playerGotSteak(Player p) {
		PersistentDataContainer cont = p.getPersistentDataContainer();
		NamespacedKey key = new NamespacedKey(this.pl, "canHasSteak");
		cont.set(key, PersistentDataType.BYTE, (byte) 69);
	}
	@EventHandler
	public void onPlayerJoin(PlayerJoinEvent e) {
    	Player p = e.getPlayer();
    	if (!(canPlayerGetSteak(p))) {
    		return;
    	}
    	ItemStack steak = new ItemStack(Material.COOKED_BEEF);
    	steak.setAmount(32);
    	playerGotSteak(p);
    	p.getInventory().addItem(steak);
    	p.sendMessage(Component.text("As this is your first time playing, you receive 32 Steak.")
    			.color(TextColor.color(0, 100, 155)));
    	Bukkit.broadcast(Component.text(p.getName() + " joined the server for the first time!")
    			.color(TextColor.color(0, 255, 0)));
	}
	public GiveSteakToPlayer(SteakOnFirstJoin plugin) {
		this.pl = plugin;
	}
}
